> For the complete documentation index, see [llms.txt](https://docs.yarnspinner.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yarnspinner.dev/3.1/api/csharp/yarn/yarn.ismartvariableevaluator/yarn.ismartvariableevaluator.trygetsmartvariable.md).

# TryGetSmartVariable\<T>(string,T)

Method in [ISmartVariableEvaluator](/3.1/api/csharp/yarn/yarn.ismartvariableevaluator.md)

## Summary

Evaluate the value of a smart variable named `name` .

```csharp
bool TryGetSmartVariable<T>(string name, out T result);
```

## Parameters

| Name          | Description                                                                                                                                                                                      |
| ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `string` name | The name of the variable.                                                                                                                                                                        |
| `T` result    | On return, contains the returned value of the smart variable, or the `default` value of `T` if a smart variable named `name` could not be found or its value could not be returned as type `T` . |

## Type Parameters

| Name | Description                     |
| ---- | ------------------------------- |
| T    | The type of the returned value. |

## Returns

`true` if the smart variable was evaluated, `false` otherwise.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/3.1/api/csharp/yarn/yarn.ismartvariableevaluator/yarn.ismartvariableevaluator.trygetsmartvariable.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
